
; CC5X Version 3.1G, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************  12. May 2021  17:09  *************

	processor  16F876
	radix  DEC

INDF        EQU   0x00
STATUS      EQU   0x03
FSR         EQU   0x04
PORTA       EQU   0x05
TRISA       EQU   0x85
PORTB       EQU   0x06
TRISB       EQU   0x86
INTCON      EQU   0x0B
Carry       EQU   0
Zero_       EQU   2
RP0         EQU   5
RP1         EQU   6
IRP         EQU   7
GIE         EQU   7
PORTC       EQU   0x07
PIR1        EQU   0x0C
PIR2        EQU   0x0D
RCSTA       EQU   0x18
TXREG       EQU   0x19
RCREG       EQU   0x1A
ADCON0      EQU   0x1F
TRISC       EQU   0x87
PIE1        EQU   0x8C
PIE2        EQU   0x8D
TXSTA       EQU   0x98
SPBRG       EQU   0x99
ADCON1      EQU   0x9F
EEDATA      EQU   0x10C
EEADR       EQU   0x10D
EEDATH      EQU   0x10E
EEADRH      EQU   0x10F
EECON2      EQU   0x18D
RCIF        EQU   5
EEIF        EQU   4
TRMT        EQU   1
RD          EQU   0
WR          EQU   1
WREN        EQU   2
EEPGD       EQU   7
b_OK        EQU   0
rxdata      EQU   0x35
bi          EQU   0x36
b_tp        EQU   0x37
dmpadrh     EQU   0x38
dmpadrl     EQU   0x39
dmpdathrd   EQU   0x3A
dmpdatlrd   EQU   0x3B
dmpdathwr   EQU   0x3C
dmpdatlwr   EQU   0x3D
SWITCH      EQU   4
fadr        EQU   0x2B
i           EQU   0x2D
j           EQU   0x2E
k           EQU   0x2F
pointr      EQU   0x31
svfadr      EQU   0x32
outcar      EQU   0x2B
rcvdata     EQU   0x20
i_2         EQU   0x21
BCC         EQU   0x23
b_fadr      EQU   0x24
OutRng      EQU   0
kflash      EQU   0x29

	GOTO main

  ; FILE Srl_bootldr.c
			;/**********************************************************
			;		RS232 SERIAL BOOTLOADER
			; 
			; - All polled, no interrupt is used in this soft.
			; - All parameters must be set in the corresponding .h file.
			; 
			; ===> after compil copy resulting asm into bo.asm.
			; 	  then recompile in assembly after replacement 
			; 	  of CALL to user soft by a GOTO usermain 
			;************************************************************/
			;
			;#include "int16Cxx.h"
			;#include "Srl_Bootldr.h"
			;
			;/****** V E C T O R  R E M A P P I N G **************************/
			;
			;  /* -----------------------------------------------------------------
			;            INTERRUPTS HANDLER                
			; 	- interrups not used for bootloader
			; 	- for live soft, a simple jump to user interrupt handler
			; --------------------------------------------------------------------- */
			;
			;#pragma origin 0x004
	ORG 0x0004
			;
			;
			;void hrdw_int_high( void)
			;{
hrdw_int_high
			;#asm
			;	call UserHighIntServ		// call chgd in goto by compiler
	GOTO  UserHighIntServ
			;#endasm
			;}
			;
			;/*------------- End Interrupts services --------------*/
			;
			;/********************************************************
			;     BOOTLOADER ROUTINES
			; **********************************************************/
			;/*
			;No tempo routing needed, only provided if changes are made and use it.
			;
			;
			;void b_tempo (uns16 dureems)
			;{
			;	while (dureems != 0)
			;	{
			;	TMR1H=TIMER1H;
			;	TMR1L=TIMER1L;
			;	TMR1IF = 0;
			;	TMR1ON = 1;
			; 	while (TMR1IF == 0);
			;	TMR1ON = 0;
			;   	dureems = dureems-1;
			;	}
			;} 
			;*/
			;
			;/* ********** FLASH WRITE P16F*********** */
			;
			;void boot_writeflash (uns16 fadr) // 64 bytes at once in bufflash
			; {
boot_writeflash
			;	char i,j,k,ad,pointr;
			;	uns16 svfadr;
			;
			;	svfadr = fadr;
	MOVF  fadr,W
	MOVWF svfadr
	MOVF  fadr+1,W
	MOVWF svfadr+1
			;	b_OK = 1;
	BSF   0x34,b_OK
			;	if (fadr >= (UserEntryAddress))	// protect booloader zone
	MOVLW .2
	SUBWF fadr+1,W
	BTFSS 0x03,Carry
	GOTO  m002
			;	{
			;		GIE = 0;		// should be already at 0, for standardizing rtg
	BCF   0x0B,GIE
			;		for (i = 0; i != 32; i++)
	CLRF  i
m001	MOVF  i,W
	XORLW .32
	BTFSC 0x03,Zero_
	GOTO  m003
			;		{
			;			svfadr = fadr + i;
	MOVF  fadr+1,W
	MOVWF svfadr+1
	MOVF  i,W
	ADDWF fadr,W
	MOVWF svfadr
	BTFSC 0x03,Carry
	INCF  svfadr+1,1
			;			EEADR = svfadr.low8;
	BSF   0x03,RP1
	MOVWF EEADR
			;			EEADRH = svfadr.high8;
	BCF   0x03,RP1
	MOVF  svfadr+1,W
	BSF   0x03,RP1
	MOVWF EEADRH
			;			pointr = i * 2;
	BCF   0x03,Carry
	BCF   0x03,RP1
	RLF   i,W
	MOVWF pointr
			;			b_bufflash[pointr+1] &= 0x3F;
	MOVLW .161
	ADDWF pointr,W
	MOVWF FSR
	BCF   0x03,IRP
	MOVLW .63
	ANDWF INDF,1
			;			EEDATA = b_bufflash[pointr];
	MOVLW .160
	ADDWF pointr,W
	MOVWF FSR
	BCF   0x03,IRP
	MOVF  INDF,W
	BSF   0x03,RP1
	MOVWF EEDATA
			;			EEDATH = b_bufflash[pointr+1];
	MOVLW .161
	BCF   0x03,RP1
	ADDWF pointr,W
	MOVWF FSR
	BCF   0x03,IRP
	MOVF  INDF,W
	BSF   0x03,RP1
	MOVWF EEDATH
			;			EEPGD = 1;
	BSF   0x03,RP0
	BSF   0x18C,EEPGD
			;			WREN = 1;
	BSF   0x18C,WREN
			;			EECON2 = 0x55;
	MOVLW .85
	MOVWF EECON2
			;			EECON2 = 0xAA;
	MOVLW .170
	MOVWF EECON2
			;			WR = 1;
	BSF   0x18C,WR
			;			nop();
	NOP  
			;			nop();
	NOP  
			;		// Next is according to a silicon errata from  Microchip 
			;		// see doc ds80053b 
			;#asm
			;	DW 0x3FFF
	DW    0x3FFF
			;	DW 0x3FFF
	DW    0x3FFF
			;	DW 0x3FFF
	DW    0x3FFF
			;	DW 0x3FFF
	DW    0x3FFF
			;	DW 0x3FFF
	DW    0x3FFF
			;	DW 0x3FFF
	DW    0x3FFF
			;	DW 0x3FFF
	DW    0x3FFF
			;	DW 0x3FFF
	DW    0x3FFF
			;	DW 0x3FFF
	DW    0x3FFF
			;	DW 0x3FFF
	DW    0x3FFF
			;	DW 0x3FFF
	DW    0x3FFF
			;	DW 0x3FFF
	DW    0x3FFF
			;	DW 0x3FFF
	DW    0x3FFF
			;	DW 0x3FFF
	DW    0x3FFF
			;	DW 0x3FFF
	DW    0x3FFF
			;	DW 0x3FFF
	DW    0x3FFF
			;	DW 0x3FFF
	DW    0x3FFF
			;	DW 0x3FFF
	DW    0x3FFF
			;	DW 0x3FFF
	DW    0x3FFF
			;	DW 0x3FFF
	DW    0x3FFF
			;#endasm
			;			WREN = 0;
	BSF   0x03,RP0
	BSF   0x03,RP1
	BCF   0x18C,WREN
			;			EEIF = 0;
	BCF   0x03,RP0
	BCF   0x03,RP1
	BCF   0x0D,EEIF
			;		}
	INCF  i,1
	GOTO  m001
			;	}
			;	else b_OK = 1;
m002	BSF   0x34,b_OK
			;
			;//	Check write
			;	if (fadr >= (UserEntryAddress))	// protect booloader zone
m003	MOVLW .2
	SUBWF fadr+1,W
	BTFSS 0x03,Carry
	GOTO  m006
			;	{
			;		for (i = 0; i != 32; i++)
	CLRF  i
m004	MOVF  i,W
	XORLW .32
	BTFSC 0x03,Zero_
	GOTO  m006
			;		{
			;			svfadr = fadr + i;
	MOVF  fadr+1,W
	MOVWF svfadr+1
	MOVF  i,W
	ADDWF fadr,W
	MOVWF svfadr
	BTFSC 0x03,Carry
	INCF  svfadr+1,1
			;			EEADR = svfadr.low8;
	BSF   0x03,RP1
	MOVWF EEADR
			;			EEADRH = svfadr.high8;
	BCF   0x03,RP1
	MOVF  svfadr+1,W
	BSF   0x03,RP1
	MOVWF EEADRH
			;			pointr = i * 2;		
	BCF   0x03,Carry
	BCF   0x03,RP1
	RLF   i,W
	MOVWF pointr
			;			EEPGD = 1;
	BSF   0x03,RP0
	BSF   0x03,RP1
	BSF   0x18C,EEPGD
			;			RD = 1;
	BSF   0x18C,RD
			;			nop();
	NOP  
			;			nop();
	NOP  
			;			j = EEDATA;
	BCF   0x03,RP0
	MOVF  EEDATA,W
	BCF   0x03,RP1
	MOVWF j
			;			k = EEDATH;
	BSF   0x03,RP1
	MOVF  EEDATH,W
	BCF   0x03,RP1
	MOVWF k
			;			if (j != b_bufflash[pointr])
	MOVLW .160
	ADDWF pointr,W
	MOVWF FSR
	BCF   0x03,IRP
	MOVF  j,W
	XORWF INDF,W
	BTFSS 0x03,Zero_
			;				b_OK = 0;
	BCF   0x34,b_OK
			;			if (k != b_bufflash[pointr+1])
	MOVLW .161
	ADDWF pointr,W
	MOVWF FSR
	BCF   0x03,IRP
	MOVF  k,W
	XORWF INDF,W
	BTFSS 0x03,Zero_
			;				b_OK = 0;
	BCF   0x34,b_OK
			;			EEIF = 0;
	BCF   0x0D,EEIF
			;			if (b_OK == 0)
	BTFSC 0x34,b_OK
	GOTO  m005
			;			{
			;				dmpadrh = svfadr.high8;
	MOVF  svfadr+1,W
	MOVWF dmpadrh
			;				dmpadrl = svfadr.low8;
	MOVF  svfadr,W
	MOVWF dmpadrl
			;				dmpdathrd = k;
	MOVF  k,W
	MOVWF dmpdathrd
			;				dmpdatlrd = j;
	MOVF  j,W
	MOVWF dmpdatlrd
			;				dmpdathwr = b_bufflash[pointr+1];
	MOVLW .161
	ADDWF pointr,W
	MOVWF FSR
	BCF   0x03,IRP
	MOVF  INDF,W
	MOVWF dmpdathwr
			;				dmpdatlwr = b_bufflash[pointr];
	MOVLW .160
	ADDWF pointr,W
	MOVWF FSR
	BCF   0x03,IRP
	MOVF  INDF,W
	MOVWF dmpdatlwr
			;			}	
			;		}
m005	INCF  i,1
	GOTO  m004
			;	}
			;}
m006	RETURN
			;	
			;
			;//  *** serial port routines
			;void boot_outsrl (char outcar)
			;	{
boot_outsrl
	MOVWF outcar
			;	while (TRMT == 0);
	BSF   0x03,RP0
m007	BTFSS 0x98,TRMT
	GOTO  m007
			;	TXREG = outcar;
	BCF   0x03,RP0
	MOVF  outcar,W
	MOVWF TXREG
			;	}
	RETURN
			;
			;char boot_waitsrl (void)
			;{
boot_waitsrl
			;while (RCIF == 0)
m008	BTFSC 0x0C,RCIF
	GOTO  m009
			;	{nop();
	NOP  
			;	nop();
	NOP  
			;	}
	GOTO  m008
			;return RCREG;
m009	MOVF  RCREG,W
	RETURN
			;}
			;
			;void bootprocess (void)
			;{
bootprocess
			;// *** main bootloader
			;
			;	char rcvdata, i, j, BCC; 
			;	uns16 b_fadr,btloop;
			;	GIE = 0;
	BCF   0x0B,GIE
			;	char tp;
			;	bit OutRng;
			;	char kflash;
			;
			;/* host synch*/
			;	bi = 0;
	CLRF  bi
			;	OutRng = 0;
	BCF   0x2A,OutRng
			;	b_tp=0;
	CLRF  b_tp
			;	kflash = FLASHCAPACITY / 2;
	MOVLW .128
	MOVWF kflash
			;	while (bi == 0)
m010	MOVF  bi,1
	BTFSS 0x03,Zero_
	GOTO  m011
			;	{
			;				rxdata = boot_waitsrl();
	CALL  boot_waitsrl
	MOVWF rxdata
			;		if (rxdata == 'R')
	XORLW .82
	BTFSS 0x03,Zero_
	GOTO  m010
			;		{
			;			nop();
	NOP  
			;			nop();
	NOP  
			;			rxdata = boot_waitsrl();
	CALL  boot_waitsrl
	MOVWF rxdata
			;
			;			if (rxdata == 'M')
	XORLW .77
	BTFSS 0x03,Zero_
	GOTO  m010
			;			{
			;				nop();
	NOP  
			;				nop();
	NOP  
			;				rxdata = boot_waitsrl();
	CALL  boot_waitsrl
	MOVWF rxdata
			;				if (rxdata == 'b')
	XORLW .98
	BTFSS 0x03,Zero_
	GOTO  m010
			;				{
			;					nop();
	NOP  
			;					nop();
	NOP  
			;					rxdata = boot_waitsrl();
	CALL  boot_waitsrl
	MOVWF rxdata
			;					if (rxdata == 't')
	XORLW .116
	BTFSS 0x03,Zero_
	GOTO  m010
			;					{
			;#ifdef LED						
			;						LED = LEDOFF;
	BCF   PORTB,1
			;#endif
			;						boot_outsrl ('b');			// Device reply with c to complete handshake
	MOVLW .98
	CALL  boot_outsrl
			;						boot_outsrl ('t');
	MOVLW .116
	CALL  boot_outsrl
			;						boot_outsrl (FLASHCAPACITY);
	MOVLW .0
	CALL  boot_outsrl
			;						bi = 1;
	MOVLW .1
	MOVWF bi
			;					}	
			;				}
			;			}
			;		} 
			;	}
	GOTO  m010
			;
			;/* tfr data */
			;	b_fadr = 0;
m011	CLRF  b_fadr
	CLRF  b_fadr+1
			;
			;// transfer format is :
			;// 27 as sart of block
			;// address high, address low, in hex.
			;// then 64 bytes follows, then check caracter
			;// When address is 0xff00: stop
			;
			;	while (b_fadr != 0xFF00)	// must complete with address FF00 to stop tfr
m012	INCF  b_fadr+1,W
	IORWF b_fadr,W
	BTFSC 0x03,Zero_
	GOTO  m020
			;	{
			;		while (boot_waitsrl() != 27);		// start of block 
m013	CALL  boot_waitsrl
	XORLW .27
	BTFSS 0x03,Zero_
	GOTO  m013
			;		rcvdata = boot_waitsrl();
	CALL  boot_waitsrl
	MOVWF rcvdata
			;		BCC = rcvdata;
	MOVWF BCC
			;		b_fadr.high8 = rcvdata;
	MOVWF b_fadr+1
			;		rcvdata = boot_waitsrl();
	CALL  boot_waitsrl
	MOVWF rcvdata
			;		BCC += rcvdata;
	ADDWF BCC,1
			;		b_fadr.low8 = rcvdata;
	MOVWF b_fadr
			;		if (b_fadr.high8 >= kflash)
	MOVF  kflash,W
	SUBWF b_fadr+1,W
	BTFSC 0x03,Carry
			;		{
			;			OutRng = 1;
	BSF   0x2A,OutRng
			;		}	
			;		if (b_fadr == 0xFF00) break;
	INCF  b_fadr+1,W
	IORWF b_fadr,W
	BTFSC 0x03,Zero_
	GOTO  m020
			;		for (i = 0;i!=64;i++)
	CLRF  i_2
m014	MOVF  i_2,W
	XORLW .64
	BTFSC 0x03,Zero_
	GOTO  m015
			;		{
			;			rcvdata = boot_waitsrl();
	CALL  boot_waitsrl
	MOVWF rcvdata
			;			BCC += rcvdata;
	ADDWF BCC,1
			;			b_bufflash[i] = rcvdata;
	MOVLW .160
	ADDWF i_2,W
	MOVWF FSR
	BCF   0x03,IRP
	MOVF  rcvdata,W
	MOVWF INDF
			;		}
	INCF  i_2,1
	GOTO  m014
			;#ifdef LED
			;		b_tp++;
m015	INCF  b_tp,1
			;		if (b_tp == 5)
	MOVF  b_tp,W
	XORLW .5
	BTFSS 0x03,Zero_
	GOTO  m016
			;		{
			;			LED = !LED;
	MOVLW .2
	XORWF PORTB,1
			;			b_tp=0;
	CLRF  b_tp
			;		}
			;#endif	
			;		rcvdata = boot_waitsrl();	// BCC caracter
m016	CALL  boot_waitsrl
	MOVWF rcvdata
			;		if (rcvdata == BCC)  
	XORWF BCC,W
	BTFSS 0x03,Zero_
	GOTO  m019
			;		{
			;			b_OK=1;
	BSF   0x34,b_OK
			;			if (OutRng == 0)
	BTFSC 0x2A,OutRng
	GOTO  m018
			;			{		
			;				boot_writeflash (b_fadr);
	MOVF  b_fadr,W
	MOVWF fadr
	MOVF  b_fadr+1,W
	MOVWF fadr+1
	CALL  boot_writeflash
			;				if (b_OK == 1)
	BTFSS 0x34,b_OK
	GOTO  m017
			;				{
			;					boot_outsrl (6);		// check is ok, reply ack
	MOVLW .6
	CALL  boot_outsrl
			;				}
			;				else
	GOTO  m012
			;				{
			;					boot_outsrl (8);
m017	MOVLW .8
	CALL  boot_outsrl
			;					boot_outsrl (dmpadrh);
	MOVF  dmpadrh,W
	CALL  boot_outsrl
			;					boot_outsrl(dmpadrl);
	MOVF  dmpadrl,W
	CALL  boot_outsrl
			;					boot_outsrl(dmpdathrd);
	MOVF  dmpdathrd,W
	CALL  boot_outsrl
			;					boot_outsrl(dmpdatlrd);
	MOVF  dmpdatlrd,W
	CALL  boot_outsrl
			;					boot_outsrl(dmpdathwr);
	MOVF  dmpdathwr,W
	CALL  boot_outsrl
			;					boot_outsrl(dmpdatlwr);
	MOVF  dmpdatlwr,W
	CALL  boot_outsrl
			;				}
			;			}
			;			else 
	GOTO  m012
			;			{
			;				boot_outsrl(9);
m018	MOVLW .9
	CALL  boot_outsrl
			;				b_fadr = 0xFF00;
	CLRF  b_fadr
	MOVLW .255
	MOVWF b_fadr+1
			;			}			
			;	
			;		}	
			;		else
	GOTO  m012
			;		{
			;				boot_outsrl (7);	// reply nack
m019	MOVLW .7
	CALL  boot_outsrl
			;		}
			;	}
	GOTO  m012
			;}
m020	RETURN
			;
			;void Initialize()
			;{
Initialize
			;	INTCON = 0;		//  disable all interrupts /
	CLRF  INTCON
			;
			;	STATUS = 0;
	CLRF  STATUS
			;	PORTA = 0; 
	CLRF  PORTA
			;	PORTB = 0;
	CLRF  PORTB
			;	PORTC = 0;  
	CLRF  PORTC
			;	TRISA = bin(111111);
	MOVLW .63
	BSF   0x03,RP0
	MOVWF TRISA
			;	TRISB = bin(11111111);
	MOVLW .255
	MOVWF TRISB
			;	TRISC = bin(11111111);
	MOVWF TRISC
			;
			;#ifdef LED
			;	TrisLed;
	BCF   TRISB,1
			;#endif
			;	/* init periph interrupts */
			;	PIE1 = bin(00000000); /* disabled int adc, usart, all polled */
	CLRF  PIE1
			;	PIR1 = 0;
	BCF   0x03,RP0
	CLRF  PIR1
			;	PIE2 = bin(00000000);	// int to clear eeprom wr 
	BSF   0x03,RP0
	CLRF  PIE2
			;	PIR2 = 0;
	BCF   0x03,RP0
	CLRF  PIR2
			;	GIE = 0;			// no interrupt, polling hrdw
	BCF   0x0B,GIE
			;	clearRAM();
	BCF   0x03,IRP
	MOVLW .32
m021	MOVWF FSR
m022	CLRF  INDF
	BSF   FSR,7
	CLRF  INDF
	BCF   FSR,7
	INCF  FSR,1
	BTFSS FSR,7
	GOTO  m022
	BTFSC 0x03,IRP
	GOTO  m023
	BSF   0x03,IRP
	MOVLW .16
	GOTO  m021
			;	/* init USART 19.2 Kbps / 8 bits*/
			;	TXSTA = 0b00100100;
m023	MOVLW .36
	BSF   0x03,RP0
	MOVWF TXSTA
			;	RCSTA = 0b10010000;
	MOVLW .144
	BCF   0x03,RP0
	MOVWF RCSTA
			;//	BRGH = 0;
			;	TRISC.6 = 1;
	BSF   0x03,RP0
	BSF   TRISC,6
			;	TRISC.7 = 1;
	BSF   TRISC,7
			;	SPBRG = (char)BAUDGEN;		//   ****** verif params in .h *******
	MOVLW .64
	MOVWF SPBRG
			;	bi = RCREG;	// dummy reads to clear buffer.
	BCF   0x03,RP0
	MOVF  RCREG,W
	MOVWF bi
			;	nop();
	NOP  
			;	bi = RCREG;
	MOVF  RCREG,W
	MOVWF bi
			;}	
	RETURN
			;
			;
			;/************* RESET ENTRY POINT ***************/
			;void main( void)
			;{
main
			;	ADCON0 = 0;		// All analog ports as digital
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  ADCON0
			;	ADCON1 = 0x07;
	MOVLW .7
	BSF   0x03,RP0
	MOVWF ADCON1
			;// next line not needed, just in case wrong manip made on previous lines
			;	TrisSw = 1;		// input of course	
	BSF   TRISB,4
			;// test if switch pressed, otherwise jump to user code
			;	if (SWITCH == SwitchActivation)
	BCF   0x03,RP0
	BTFSC 0x06,SWITCH
	GOTO  m024
			;	{
			;		Initialize();
	CALL  Initialize
			;#ifdef LED
			;	LED = LEDON;
	BSF   PORTB,1
			;#endif
			;		bootprocess();
	CALL  bootprocess
			;	}
			;// if switch not pressed goto user startup
			;
			;// CC5X does not allow a goto here below
			;// only way to change to GOTO is to recompile in assembly later
			;
			;	#asm
			;		CALL usermain		// call should be chgd in goto in asm
m024	CALL  usermain
			;	#endasm
			;
			;}
	SLEEP
	GOTO main
			;
			;/* ---------------------------------------------------------
			;              DUMMY MAIN        
			; 	- This part is only here to generate the necessary
			; 	  adresses for the direct calls                           
			; ---------------------------------------------------------*/
			;
			;#pragma origin UserEntryAddress
	ORG 0x0200
			;void usermain( void)
			;{
usermain
			;// user code should start like the following code :
			;#asm
			;	call userreset
	GOTO  userreset
			;#endasm
			;}
			;
			;#pragma origin UserHInt
	ORG 0x0204
			;
			;void UserHighIntServ (void)
			;{
UserHighIntServ
			;}
	RETURN
			;
			;
			;//  small example of structure of user code :	
			;void MainLoop (void)
			;{
MainLoop
			;}
	RETURN
			;
			;void SystemInit (void)
			;{
SystemInit
			;}		
	RETURN
			;void userreset ( void)
			;{
userreset
			; 	SystemInit();
	CALL  SystemInit
			;	while (1)
			;	{
			;		TRISB.2 = 0;
m025	BSF   0x03,RP0
	BCF   TRISB,2
			;		PORTB.2 = 1;
	BCF   0x03,RP0
	BSF   PORTB,2
			;		MainLoop();
	CALL  MainLoop
			;	}	
	GOTO  m025

	ORG 0x2007
	DATA 3F72H
	END


; *** KEY INFO ***
; RAM usage: 94 bytes (20 local), 274 bytes free
; Maximum call level: 2
;  Codepage 0 has  429 word(s) :  20 %
;  Codepage 1 has    0 word(s) :   0 %
;  Codepage 2 has    0 word(s) :   0 %
;  Codepage 3 has    0 word(s) :   0 %
; Total of 409 code words (4 %)

; P0    1 word(s),  0 %: usermain
; P0    1 word(s),  0 %: UserHighIntServ
; P0    7 word(s),  0 %: userreset
; P0    1 word(s),  0 %: hrdw_int_high
; P0  174 word(s),  8 %: boot_writeflash
; P0    8 word(s),  0 %: boot_outsrl
; P0    7 word(s),  0 %: boot_waitsrl
; P0  138 word(s),  6 %: bootprocess
; P0   53 word(s),  2 %: Initialize
; P0   16 word(s),  0 %: main
; P0    1 word(s),  0 %: MainLoop
; P0    1 word(s),  0 %: SystemInit
