
; CC5X Version 3.8, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************  11. May 2021  11:42  *************

        processor  16F1825
        radix  DEC

INDF0       EQU   0x00
STATUS      EQU   0x03
FSR0L       EQU   0x04
FSR0H       EQU   0x05
INTCON      EQU   0x0B
Carry       EQU   0
Zero_       EQU   2
PORTA       EQU   0x0C
PORTC       EQU   0x0E
PIR1        EQU   0x11
TRISA       EQU   0x8C
TRISC       EQU   0x8E
PIE1        EQU   0x91
OSCCON      EQU   0x99
OSCSTAT     EQU   0x9A
ADCON0      EQU   0x9D
ADCON1      EQU   0x9E
LATA        EQU   0x10C
ANSELA      EQU   0x18C
ANSELC      EQU   0x18E
EEADRL      EQU   0x191
EEADRH      EQU   0x192
EEDATL      EQU   0x193
EEDATH      EQU   0x194
EECON2      EQU   0x196
RCREG       EQU   0x199
TXREG       EQU   0x19A
SPBRGL      EQU   0x19B
SPBRGH      EQU   0x19C
RCSTA       EQU   0x19D
TXSTA       EQU   0x19E
BAUDCON     EQU   0x19F
GIE         EQU   7
RCIF        EQU   5
EEIF        EQU   4
EEIE        EQU   4
RD          EQU   0
WR          EQU   1
WREN        EQU   2
FREE        EQU   4
LWLO        EQU   5
CFGS        EQU   6
EEPGD       EQU   7
TRMT        EQU   1
boot_OK     EQU   1
rxdata      EQU   0x2B
bi          EQU   0x2C
boot_tp     EQU   0x2D
dmpadrh     EQU   0x2E
dmpadrl     EQU   0x2F
dmpdathrd   EQU   0x30
dmpdatlrd   EQU   0x31
dmpdathwr   EQU   0x32
dmpdatlwr   EQU   0x33
boot_bufflash EQU   0xA0
fadr        EQU   0x70
k           EQU   0x74
pointr      EQU   0x78
svfadr      EQU   0x79
locadr      EQU   0x7B
fadr_2      EQU   0x70
j_2         EQU   0x73
k_2         EQU   0x74
l_2         EQU   0x75
m_2         EQU   0x76
n_2         EQU   0x77
pointr_2    EQU   0x78
svfadr_2    EQU   0x79
outcar      EQU   0x70
rcvdata     EQU   0x20
i_3         EQU   0x21
BCC         EQU   0x23
boot_fadr   EQU   0x24
OutRng      EQU   0
kflash      EQU   0x29

        GOTO main

  ; FILE Srl_bootldr.c
                        ;/**********************************************************
                        ;		RS232 SERIAL BOOTLOADER
                        ; 
                        ; >>>>>>>>>>>>>>>>>>> SPECIFIC 16F EXTENDED SERIES ><<<<<<<<<	
                        ;  - All polled, no interrupt is used in this soft.
                        ; - All parameters must be set in the corresponding .h file.
                        ; 
                        ; ===> after compil copy resulting asm into bo.asm.
                        ; 	  then recompile in assembly after replacement 
                        ; 	  of CALL to user soft by a GOTO usermain 
                        ;************************************************************/
                        ;
                        ;#include "Srl_Bootldr.h"
                        ;
                        ;/****** V E C T O R  R E M A P P I N G **************************/
                        ;
                        ;  /* -----------------------------------------------------------------
                        ;            INTERRUPTS HANDLER                
                        ; 	- interrups not used for bootloader
                        ; 	- for live soft, a simple jump to user interrupt handler
                        ; --------------------------------------------------------------------- */
                        ;
                        ;#pragma origin 0x004
        ORG 0x0004
                        ;
                        ;
                        ;void hrdw_int_high( void)
                        ;{
hrdw_int_high
                        ;#asm
                        ;	CALL UserHighIntServ		// call chgd in goto by compiler
        GOTO  UserHighIntServ
                        ;#endasm
                        ;}
                        ;
                        ;/*------------- End Interrupts services --------------*/
                        ;
                        ;/********************************************************
                        ;     BOOTLOADER ROUTINES
                        ; **********************************************************/
                        ;
                        ;
                        ;/* ********** FLASH WRITE P16F*********** */
                        ;#pragma rambank -
                        ;void boot_writeflash (uns16 fadr) // 64 bytes at once in bufflash
                        ; {
boot_writeflash
                        ;	char i,j,k,l,m,n,pointr;
                        ;	uns16 svfadr;
                        ;	uns16 locadr;
                        ;	
                        ;	svfadr = fadr;
        MOVF  fadr,W
        MOVWF svfadr
        MOVF  fadr+1,W
        MOVWF svfadr+1
                        ;	locadr = fadr;
        MOVF  fadr,W
        MOVWF locadr
        MOVF  fadr+1,W
        MOVWF locadr+1
                        ;	boot_OK = 1;
        MOVLB 0
        BSF   0x2A,boot_OK
                        ;	GIE = 0;		// should be already at 0, for standardizi	
        BCF   0x0B,GIE
                        ;	EEIE = 0;
        MOVLB 1
        BCF   0x92,EEIE
                        ;	if (fadr >= (UserEntryAddress))	// protect booloader zone
        MOVLW 2
        SUBWF fadr+1,W
        BTFSS 0x03,Carry
        GOTO  m003
                        ;	{
                        ;		// *** first erase block
                        ;		EEADRH = locadr.high8;
        MOVF  locadr+1,W
        MOVLB 3
        MOVWF EEADRH
                        ;		EEADRL = locadr.low8;
        MOVF  locadr,W
        MOVWF EEADRL
                        ;		EEIF = 0;
        MOVLB 0
        BCF   0x12,EEIF
                        ;		CFGS = 0;
        MOVLB 3
        BCF   0x195,CFGS
                        ;		EEPGD = 1;
        BSF   0x195,EEPGD
                        ;		FREE = 1;
        BSF   0x195,FREE
                        ;		WREN = 1;
        BSF   0x195,WREN
                        ;		EECON2 = 0x55;
        MOVLW 85
        MOVWF EECON2
                        ;		EECON2 = 0xAA;
        MOVLW 170
        MOVWF EECON2
                        ;		WR = 1;
        BSF   0x195,WR
                        ;		nop();
        NOP  
                        ;		nop();
        NOP  
                        ;		FREE = 0;
        BCF   0x195,FREE
                        ;		
                        ;		//  ***  then write data
                        ;		EEADRH = locadr.high8;
        MOVF  locadr+1,W
        MOVWF EEADRH
                        ;		EEADRL = locadr.low8;
        MOVF  locadr,W
        MOVWF EEADRL
                        ;		EEPGD = 1;
        BSF   0x195,EEPGD
                        ;		CFGS = 0;
        BCF   0x195,CFGS
                        ;		WREN = 1;
        BSF   0x195,WREN
                        ;		LWLO = 1;	// select latches
        BSF   0x195,LWLO
                        ;		EEIF =0;
        MOVLB 0
        BCF   0x12,EEIF
                        ;		// write latches loop
                        ;		for (k = 0; k != 32; k++)
        CLRF  k
m001    MOVF  k,W
        XORLW 32
        BTFSC 0x03,Zero_
        GOTO  m002
                        ;		{
                        ;			EEIF = 0;
        MOVLB 0
        BCF   0x12,EEIF
                        ;			svfadr = locadr + k;
        MOVF  locadr+1,W
        MOVWF svfadr+1
        MOVF  k,W
        ADDWF locadr,W
        MOVWF svfadr
        BTFSC 0x03,Carry
        INCF  svfadr+1,1
                        ;			pointr = k * 2;
        BCF   0x03,Carry
        RLF   k,W
        MOVWF pointr
                        ;			boot_bufflash[pointr+1] &= 0x3F;
        MOVLW 161
        ADDWF pointr,W
        MOVWF FSR0L
        CLRF  FSR0H
        MOVLW 63
        ANDWF INDF0,1
                        ;			EEDATL = boot_bufflash[pointr];
        MOVLW 160
        ADDWF pointr,W
        MOVWF FSR0L
        CLRF  FSR0H
        MOVF  INDF0,W
        MOVLB 3
        MOVWF EEDATL
                        ;			EEDATH = boot_bufflash[pointr+1];
        MOVLW 161
        ADDWF pointr,W
        MOVWF FSR0L
        CLRF  FSR0H
        MOVF  INDF0,W
        MOVWF EEDATH
                        ;			EECON2 = 0x55;
        MOVLW 85
        MOVWF EECON2
                        ;			EECON2 = 0xAA;
        MOVLW 170
        MOVWF EECON2
                        ;			WR = 1;
        BSF   0x195,WR
                        ;			nop();
        NOP  
                        ;			nop();
        NOP  
                        ;			EEADRL++;
        INCF  EEADRL,1
                        ;		}
        INCF  k,1
        GOTO  m001
                        ;			// write flash now
                        ;		EEIF = 0;
m002    MOVLB 0
        BCF   0x12,EEIF
                        ;		LWLO = 0;		// select flash
        MOVLB 3
        BCF   0x195,LWLO
                        ;		EEADRL = locadr.low8;
        MOVF  locadr,W
        MOVWF EEADRL
                        ;		EEDATL = boot_bufflash[0];
        MOVLB 1
        MOVF  boot_bufflash,W
        MOVLB 3
        MOVWF EEDATL
                        ;		EEDATH = boot_bufflash[1];		
        MOVLB 1
        MOVF  boot_bufflash+1,W
        MOVLB 3
        MOVWF EEDATH
                        ;		EECON2 = 0x55;
        MOVLW 85
        MOVWF EECON2
                        ;		EECON2 = 0xAA;
        MOVLW 170
        MOVWF EECON2
                        ;		WR = 1;
        BSF   0x195,WR
                        ;		nop();
        NOP  
                        ;		nop();
        NOP  
                        ;		nop();
        NOP  
                        ;		nop();
        NOP  
                        ;		nop();
        NOP  
                        ;		nop();
        NOP  
                        ;		nop();
        NOP  
                        ;		nop();
        NOP  
                        ;		WREN = 0;
        BCF   0x195,WREN
                        ;		LED = !LED;
        MOVLW 16
        MOVLB 2
        XORWF LATA,1
                        ;	}
                        ;	else boot_OK = 1;
        GOTO  m004
m003    MOVLB 0
        BSF   0x2A,boot_OK
                        ;}
m004    RETURN
                        ;
                        ;bit verif (uns16 fadr)	
                        ;{
verif
                        ;	char i,j,k,l,m,n,pointr;
                        ;	uns16 svfadr;
                        ;	uns16 locadr;
                        ;	
                        ;	boot_OK = 1;
        MOVLB 0
        BSF   0x2A,boot_OK
                        ;// Method 2 read flash inprogramming mode
                        ;	if (fadr >= (UserEntryAddress))	// ignore booloader zone
        MOVLW 2
        SUBWF fadr_2+1,W
        BTFSS 0x03,Carry
        GOTO  m008
                        ;	{
                        ;		EEIF = 0;
        BCF   0x12,EEIF
                        ;		CFGS = 0;
        MOVLB 3
        BCF   0x195,CFGS
                        ;		EEPGD = 1;
        BSF   0x195,EEPGD
                        ;		for (n = 0; n != 32; n++)
        CLRF  n_2
m005    MOVF  n_2,W
        XORLW 32
        BTFSC 0x03,Zero_
        GOTO  m008
                        ;		{
                        ;			svfadr = fadr + n;
        MOVF  fadr_2+1,W
        MOVWF svfadr_2+1
        MOVF  n_2,W
        ADDWF fadr_2,W
        MOVWF svfadr_2
        BTFSC 0x03,Carry
        INCF  svfadr_2+1,1
                        ;			EEIF = 0;
        MOVLB 0
        BCF   0x12,EEIF
                        ;			CFGS = 0;
        MOVLB 3
        BCF   0x195,CFGS
                        ;			EEPGD = 1;
        BSF   0x195,EEPGD
                        ;			EEADRL = svfadr.low8;
        MOVF  svfadr_2,W
        MOVWF EEADRL
                        ;			EEADRH = svfadr.high8;
        MOVF  svfadr_2+1,W
        MOVWF EEADRH
                        ;			pointr = n * 2;		
        BCF   0x03,Carry
        RLF   n_2,W
        MOVWF pointr_2
                        ;			RD = 1;
        BSF   0x195,RD
                        ;			nop();
        NOP  
                        ;			nop();
        NOP  
                        ;			nop();
        NOP  
                        ;			nop();
        NOP  
                        ;			k = EEDATL;
        MOVF  EEDATL,W
        MOVWF k_2
                        ;			j = EEDATH;
        MOVF  EEDATH,W
        MOVWF j_2
                        ;			j = j & 0x3F;
        MOVLW 63
        ANDWF j_2,1
                        ;			l = boot_bufflash[pointr] & 0x3F;
        MOVLW 160
        ADDWF pointr_2,W
        MOVWF FSR0L
        CLRF  FSR0H
        MOVLW 63
        ANDWF INDF0,W
        MOVWF l_2
                        ;			m = boot_bufflash[pointr+1];
        MOVLW 161
        ADDWF pointr_2,W
        MOVWF FSR0L
        CLRF  FSR0H
        MOVF  INDF0,W
        MOVWF m_2
                        ;			if (j !=l)	boot_OK = 0;
        MOVF  j_2,W
        XORWF l_2,W
        BTFSC 0x03,Zero_
        GOTO  m006
        MOVLB 0
        BCF   0x2A,boot_OK
                        ;			if (k != m) boot_OK = 0;
m006    MOVF  k_2,W
        XORWF m_2,W
        BTFSC 0x03,Zero_
        GOTO  m007
        MOVLB 0
        BCF   0x2A,boot_OK
                        ;		}
m007    INCF  n_2,1
        GOTO  m005
                        ;	}
                        ;	return boot_OK;
m008    BCF   0x03,Carry
        MOVLB 0
        BTFSC 0x2A,boot_OK
        BSF   0x03,Carry
        RETURN
                        ;}
                        ;	
                        ;#pragma rambank -
                        ;//  *** serial port routines
                        ;void boot_outsrl (char outcar)
                        ;	{
boot_outsrl
        MOVWF outcar
                        ;	while (TRMT == 0);
m009    MOVLB 3
        BTFSS 0x19E,TRMT
        GOTO  m009
                        ;	TXREG = outcar;
        MOVF  outcar,W
        MOVLB 3
        MOVWF TXREG
                        ;	}
        RETURN
                        ;
                        ;char boot_waitsrl (void)
                        ;{
boot_waitsrl
                        ;while (RCIF == 0)
m010    MOVLB 0
        BTFSC 0x11,RCIF
        GOTO  m011
                        ;	{nop();
        NOP  
                        ;	nop();
        NOP  
                        ;	}
        GOTO  m010
                        ;return RCREG;
m011    MOVLB 3
        MOVF  RCREG,W
        RETURN
                        ;}
                        ;
                        ;#pragma rambank 0
                        ;void bootprocess (void)
                        ;{
bootprocess
                        ;// *** main bootloader
                        ;
                        ;	char rcvdata, i, j, BCC; 
                        ;	uns16 boot_fadr,btloop;
                        ;	char tp;
                        ;	bit OutRng;
                        ;	char kflash;
                        ;
                        ;	GIE = 0;		// no interrupt, polling only
        BCF   0x0B,GIE
                        ;/* host synch*/
                        ;	bi = 0;
        MOVLB 0
        CLRF  bi
                        ;	OutRng = 0;
        BCF   0x2A,OutRng
                        ;	boot_tp=0;
        CLRF  boot_tp
                        ;	kflash = FLASHCAPACITY / 2;
        MOVLW 16
        MOVWF kflash
                        ;	while (bi == 0)
m012    MOVLB 0
        MOVF  bi,1
        BTFSS 0x03,Zero_
        GOTO  m013
                        ;	{
                        ;				rxdata = boot_waitsrl();
        CALL  boot_waitsrl
        MOVLB 0
        MOVWF rxdata
                        ;		if (rxdata == 'R')
        MOVF  rxdata,W
        XORLW 82
        BTFSS 0x03,Zero_
        GOTO  m012
                        ;		{
                        ;			nop();
        NOP  
                        ;			nop();
        NOP  
                        ;			rxdata = boot_waitsrl();
        CALL  boot_waitsrl
        MOVLB 0
        MOVWF rxdata
                        ;
                        ;			if (rxdata == 'M')
        MOVF  rxdata,W
        XORLW 77
        BTFSS 0x03,Zero_
        GOTO  m012
                        ;			{
                        ;				nop();
        NOP  
                        ;				nop();
        NOP  
                        ;				rxdata = boot_waitsrl();
        CALL  boot_waitsrl
        MOVLB 0
        MOVWF rxdata
                        ;				if (rxdata == 'b')
        MOVF  rxdata,W
        XORLW 98
        BTFSS 0x03,Zero_
        GOTO  m012
                        ;				{
                        ;					nop();
        NOP  
                        ;					nop();
        NOP  
                        ;					rxdata = boot_waitsrl();
        CALL  boot_waitsrl
        MOVLB 0
        MOVWF rxdata
                        ;					if (rxdata == 't')
        MOVF  rxdata,W
        XORLW 116
        BTFSS 0x03,Zero_
        GOTO  m012
                        ;					{
                        ;						LED = LEDOFF;
        MOVLB 2
        BCF   LATA,4
                        ;						boot_outsrl ('b');			// Device reply with c to complete handshake
        MOVLW 98
        CALL  boot_outsrl
                        ;						boot_outsrl ('t');
        MOVLW 116
        CALL  boot_outsrl
                        ;						boot_outsrl (FLASHCAPACITY);
        MOVLW 32
        CALL  boot_outsrl
                        ;						bi = 1;
        MOVLW 1
        MOVLB 0
        MOVWF bi
                        ;					}	
                        ;				}
                        ;			}
                        ;		} 
                        ;	}
        GOTO  m012
                        ;
                        ;/* tfr data */
                        ;	boot_fadr = 0;
m013    MOVLB 0
        CLRF  boot_fadr
        CLRF  boot_fadr+1
                        ;
                        ;// transfer format is :
                        ;// 27 as sart of block
                        ;// address high, address low, in hex.
                        ;// then 64 bytes follows, then check caracter
                        ;// When address is 0xff00: stop
                        ;
                        ;	while (boot_fadr != 0xFF00)	// must complete with address FF00 to stop tfr
m014    MOVLB 0
        INCF  boot_fadr+1,W
        IORWF boot_fadr,W
        BTFSC 0x03,Zero_
        GOTO  m024
                        ;	{
                        ;		rxdata = boot_waitsrl();
        CALL  boot_waitsrl
        MOVLB 0
        MOVWF rxdata
                        ;		while (rxdata != 27)		// start of block 
m015    MOVLB 0
        MOVF  rxdata,W
        XORLW 27
        BTFSC 0x03,Zero_
        GOTO  m018
                        ;		{
                        ;			if (rxdata == 28)	// verif loop
        MOVF  rxdata,W
        XORLW 28
        BTFSS 0x03,Zero_
        GOTO  m017
                        ;			{
                        ;				if (verif (boot_fadr) == 1)
        MOVF  boot_fadr,W
        MOVWF fadr_2
        MOVF  boot_fadr+1,W
        MOVWF fadr_2+1
        CALL  verif
        BTFSS 0x03,Carry
        GOTO  m016
                        ;				{
                        ;					boot_outsrl (6);
        MOVLW 6
        CALL  boot_outsrl
                        ;				}
                        ;				else
        GOTO  m017
                        ;				{
                        ;					boot_outsrl(8);		// for test, must be 8
m016    MOVLW 8
        CALL  boot_outsrl
                        ;				}		
                        ;			}
                        ;			rxdata = boot_waitsrl();
m017    CALL  boot_waitsrl
        MOVLB 0
        MOVWF rxdata
                        ;		}
        GOTO  m015
                        ;		rcvdata = boot_waitsrl();
m018    CALL  boot_waitsrl
        MOVLB 0
        MOVWF rcvdata
                        ;		BCC = rcvdata;
        MOVF  rcvdata,W
        MOVWF BCC
                        ;		boot_fadr.high8 = rcvdata;
        MOVF  rcvdata,W
        MOVWF boot_fadr+1
                        ;		rcvdata = boot_waitsrl();
        CALL  boot_waitsrl
        MOVLB 0
        MOVWF rcvdata
                        ;		BCC += rcvdata;
        MOVF  rcvdata,W
        ADDWF BCC,1
                        ;		boot_fadr.low8 = rcvdata;
        MOVF  rcvdata,W
        MOVWF boot_fadr
                        ;		if (boot_fadr == 0xFF00) break;
        INCF  boot_fadr+1,W
        IORWF boot_fadr,W
        BTFSC 0x03,Zero_
        GOTO  m024
                        ;		for (i = 0;i!=64;i++)
        MOVLB 0
        CLRF  i_3
m019    MOVLB 0
        MOVF  i_3,W
        XORLW 64
        BTFSC 0x03,Zero_
        GOTO  m020
                        ;		{
                        ;			rcvdata = boot_waitsrl();
        CALL  boot_waitsrl
        MOVLB 0
        MOVWF rcvdata
                        ;			BCC += rcvdata;
        MOVF  rcvdata,W
        ADDWF BCC,1
                        ;			boot_bufflash[i] = rcvdata;
        MOVLW 160
        ADDWF i_3,W
        MOVWF FSR0L
        CLRF  FSR0H
        MOVF  rcvdata,W
        MOVWF INDF0
                        ;		}
        INCF  i_3,1
        GOTO  m019
                        ;#ifdef LED
                        ;		boot_tp++;
m020    MOVLB 0
        INCF  boot_tp,1
                        ;		if (boot_tp == 5)
        MOVF  boot_tp,W
        XORLW 5
        BTFSC 0x03,Zero_
                        ;		{
                        ;//			LED = !LED;
                        ;			boot_tp=0;
        CLRF  boot_tp
                        ;		}
                        ;#endif	
                        ;		rcvdata = boot_waitsrl();	// BCC caracter
        CALL  boot_waitsrl
        MOVLB 0
        MOVWF rcvdata
                        ;		if (rcvdata == BCC)  
        MOVF  rcvdata,W
        XORWF BCC,W
        BTFSS 0x03,Zero_
        GOTO  m023
                        ;		{
                        ;			boot_OK=1;
        BSF   0x2A,boot_OK
                        ;			if (OutRng == 0)
        BTFSC 0x2A,OutRng
        GOTO  m022
                        ;			{		
                        ;				boot_writeflash (boot_fadr);
        MOVF  boot_fadr,W
        MOVWF fadr
        MOVF  boot_fadr+1,W
        MOVWF fadr+1
        CALL  boot_writeflash
                        ;				if (boot_OK == 1)
        MOVLB 0
        BTFSS 0x2A,boot_OK
        GOTO  m021
                        ;				{
                        ;					boot_outsrl (6);		// check is ok, reply ack
        MOVLW 6
        CALL  boot_outsrl
                        ;				}
                        ;				else
        GOTO  m014
                        ;				{
                        ;					boot_outsrl (8);		// reply 8 for error write
m021    MOVLW 8
        CALL  boot_outsrl
                        ;					boot_outsrl (dmpadrh);
        MOVLB 0
        MOVF  dmpadrh,W
        CALL  boot_outsrl
                        ;					boot_outsrl(dmpadrl);
        MOVLB 0
        MOVF  dmpadrl,W
        CALL  boot_outsrl
                        ;					boot_outsrl(dmpdathrd);
        MOVLB 0
        MOVF  dmpdathrd,W
        CALL  boot_outsrl
                        ;					boot_outsrl(dmpdatlrd);
        MOVLB 0
        MOVF  dmpdatlrd,W
        CALL  boot_outsrl
                        ;					boot_outsrl(dmpdathwr);
        MOVLB 0
        MOVF  dmpdathwr,W
        CALL  boot_outsrl
                        ;					boot_outsrl(dmpdatlwr);
        MOVLB 0
        MOVF  dmpdatlwr,W
        CALL  boot_outsrl
                        ;
                        ;				}
                        ;			}
                        ;			else 
        GOTO  m014
                        ;			{
                        ;				boot_outsrl(9);
m022    MOVLW 9
        CALL  boot_outsrl
                        ;//				boot_fadr = 0xFF00;
                        ;			}			
                        ;	
                        ;		}	
                        ;		else
        GOTO  m014
                        ;		{
                        ;				boot_outsrl (7);	// reply nack, comm error
m023    MOVLW 7
        CALL  boot_outsrl
                        ;		}
                        ;	}
        GOTO  m014
                        ;}
m024    RETURN
                        ;
                        ;void Initialize()
                        ;{
Initialize
                        ;	INTCON = 0;		//  disable all interrupts /
        CLRF  INTCON
                        ;	STATUS = 0;
        CLRF  STATUS
                        ;	PORTA = 0; 
        MOVLB 0
        CLRF  PORTA
                        ;	PORTC = 0;  
        CLRF  PORTC
                        ;	TRISA = bin(111111);
        MOVLW 63
        MOVLB 1
        MOVWF TRISA
                        ;	TRISC = bin(11111111);
        MOVLW 255
        MOVWF TRISC
                        ;
                        ;#ifdef LED
                        ;	TrisLed;
        BCF   TRISA,4
                        ;#endif
                        ;	/* init periph interrupts */
                        ;	PIE1 = bin(00000000); /* disabled int adc, usart, all polled */
        CLRF  PIE1
                        ;	PIR1 = 0;
        MOVLB 0
        CLRF  PIR1
                        ;	GIE = 0;			// no interrupt, polling hrdw
        BCF   0x0B,GIE
                        ;	clearRAM();
        MOVLW 239
        MOVWF FSR0L
        MOVLW 35
        MOVWF FSR0H
        MOVLW 0
m025    MOVWI INDF0--
        BTFSC FSR0H,5
        GOTO  m025
        MOVWF FSR0H
m026    MOVWI INDF0--
        BTFSC FSR0L,4
        GOTO  m026
                        ;	/* init USART 19.2 Kbps / 8 bits*/
                        ;	//config USART
                        ;	TXSTA = 0b00100110;
        MOVLW 38
        MOVLB 3
        MOVWF TXSTA
                        ;	RCSTA = 0b10010000;
        MOVLW 144
        MOVWF RCSTA
                        ;	BAUDCON = 0b00001000;
        MOVLW 8
        MOVWF BAUDCON
                        ;	SPBRGL = BAUDGEN;
        MOVLW 51
        MOVWF SPBRGL
                        ;	
                        ;	SPBRGH = 0;
        CLRF  SPBRGH
                        ;	#if (BAUDGEN) > (255)
                        ;	SPBRGH = BAUDGEN / 256;
                        ;	#endif
                        ;	TRISC.4 = 1;
        MOVLB 1
        BSF   TRISC,4
                        ;	TRISC.5 = 1;
        BSF   TRISC,5
                        ;	nop();
        NOP  
                        ;	bi = RCREG;		// dummy read to clear buffer
        MOVLB 3
        MOVF  RCREG,W
        MOVLB 0
        MOVWF bi
                        ;	nop();
        NOP  
                        ;	bi = RCREG;
        MOVLB 3
        MOVF  RCREG,W
        MOVLB 0
        MOVWF bi
                        ;}	
        RETURN
                        ;
                        ;
                        ;/************* RESET ENTRY POINT ***************/
                        ;void main( void)
                        ;{
main
                        ;	OSCCON = 0b01101010;	// 4MHz intnl oscilator
        MOVLW 106
        MOVLB 1
        MOVWF OSCCON
                        ;	OSCSTAT = 1;
        MOVLW 1
        MOVWF OSCSTAT
                        ;	ADCON0 = 0;		// All analog ports as digital
        CLRF  ADCON0
                        ;	ADCON1 = 0x07;
        MOVLW 7
        MOVWF ADCON1
                        ;	ANSELA = 0;
        MOVLB 3
        CLRF  ANSELA
                        ;	ANSELC = 0;
        CLRF  ANSELC
                        ;// next line not needed, just in case wrong manip made on previous lines
                        ;	TrisSw = 1;		// input of course	
        MOVLB 1
        BSF   TRISA,5
                        ;// test if switch pressed, otherwise jump to user code
                        ;	if (SWITCH == SwitchActivation)
        MOVLB 0
        BTFSC PORTA,5
        GOTO  m027
                        ;	{
                        ;		Initialize();
        CALL  Initialize
                        ;#ifdef LED
                        ;		LED = LEDON;
        MOVLB 2
        BSF   LATA,4
                        ;#endif
                        ;		bootprocess();
        CALL  bootprocess
                        ;	}
                        ;// if switch not pressed goto user startup
                        ;
                        ;// CC5X does not allow a goto here below
                        ;// only way to change to GOTO is to use assembler later
                        ;
                        ;	#asm
                        ;		CALL usermain		// call should be chgd in goto in asm
m027    CALL  usermain
                        ;	#endasm
                        ;
                        ;}
        SLEEP
        GOTO main
                        ;
                        ;/* ---------------------------------------------------------
                        ;              DUMMY MAIN        
                        ; 	- This part is only here to generate the necessary
                        ; 	  adresses for the direct calls                           
                        ; ---------------------------------------------------------*/
                        ;#pragma origin UserEntryAddress
        ORG 0x0200
                        ;void usermain( void)
                        ;{
usermain
                        ;// user code should start like the following code :
                        ;
                        ;#asm
                        ;	call userreset
        GOTO  userreset
                        ;#endasm
                        ;
                        ;}
                        ;
                        ;#pragma origin UserHInt
        ORG 0x0204
                        ;
                        ;void UserHighIntServ (void)
                        ;{
UserHighIntServ
                        ;}
        RETURN
                        ;
                        ;//  small example of structure of user code :	
                        ;void MainLoop (void)
                        ;{
MainLoop
                        ;}
        RETURN
                        ;
                        ;void SystemInit (void)
                        ;{
SystemInit
                        ;}
        RETURN
                        ;
                        ;void userreset ( void)
                        ;{
userreset
                        ; 	SystemInit();
        CALL  SystemInit
                        ;	while (1)
                        ;	{
                        ;		MainLoop();
m028    CALL  MainLoop
                        ;	}	
        GOTO  m028

        END


; *** KEY INFO ***

; 0x0200 P0    1 word(s)  0 % : usermain
; 0x0204 P0    1 word(s)  0 % : UserHighIntServ
; 0x0207 P0    3 word(s)  0 % : userreset
; 0x0004 P0    1 word(s)  0 % : hrdw_int_high
; 0x0005 P0  128 word(s)  6 % : boot_writeflash
; 0x0085 P0   77 word(s)  3 % : verif
; 0x00D2 P0    8 word(s)  0 % : boot_outsrl
; 0x00DA P0    9 word(s)  0 % : boot_waitsrl
; 0x00E3 P0  186 word(s)  9 % : bootprocess
; 0x019D P0   51 word(s)  2 % : Initialize
; 0x01D0 P0   23 word(s)  1 % : main
; 0x0205 P0    1 word(s)  0 % : MainLoop
; 0x0206 P0    1 word(s)  0 % : SystemInit

; RAM usage: 97 bytes (23 local), 927 bytes free
; Maximum call level: 2
;  Codepage 0 has  491 word(s) :  23 %
;  Codepage 1 has    0 word(s) :   0 %
;  Codepage 2 has    0 word(s) :   0 %
;  Codepage 3 has    0 word(s) :   0 %
; Total of 491 code words (5 %)
