/**************I 2 C   ROUTINES *****************/
#include "I2CMasterRtgs.h"
	
/**************I 2 C   ROUTINES *****************/
/*
POLLING MODE
Each dialog is a tx of n caracters, eventually followed by a rcv of m others.
Parametre passed = nbr of caracters to send and to rcv
TMRI2C is duration in us of timout maxi waiting response
This timer is used as a software lock safeguard, returning an error if timeout
I2Cbufout[0 .. n-1] buffer  of n caracters to txmt, n is nbrout 
I2Cbufin[0 .. n-1] n caracteres rcvd, nbr according to param passed nbin
*/
void I2Cout (char nbrout, char nbin)
{
	char count,nbrwr;
	bit wr_plus_rd;
	i2cerrin = 0;
	i2cerrout = 0;
	i2cstate = 0;
	count = SSPBUF;
	SSPIF = 0;
	if ((nbrout != 0) && (nbin != 0))
	{
		wr_plus_rd = 1;
	}
	else
	{
		wr_plus_rd = 0;
	}
	BCLIF = 0;
	TMR1H = 100;	// starts timeout timer around 5 ms with 12 Mhz
	TMR1L = 1;		// if send fail, abort with error code
	TMR1IF = 0;
	TMR1ON = 1;
/* ----------- send part */
	iadr = iadr & 0xFE;
	SEN=1;
	i2cstate = 1;
	while (SSPIF == 0 && TMR1IF == 0);
	while (SEN == 1);
	SSPBUF=iadr;	// i2c device address with r/w=0
	while (RW_ == 1)
		{
			i2cstate = 2;	// wait completion of adr write, including ack returned
		}
	if (ACKSTAT == 1)
		{
			i2cerrout = 0x31;	// nack returned
		}
	i2cstate = 3;
	SSPIF = 0;
	count = 0;
	if (TMR1IF == 0)
	{
		while (nbrout!=0 && i2cerrout == 0)
		{
			while (SSPIF == 0 && TMR1IF == 0);
			while (RW_ == 1);
			if (ACKSTAT == 1)
			{
				i2cerrout = 0x31;	// nack returned
			}
			SSPBUF = I2Cbufout[count];
			i2cstate = 4;
			SSPIF = 0;
			if (TMR1IF == 1)
			{
				i2cerrout = 0x32;
			}	// timeout on read
			count = count + 1;
			nbrout = nbrout - 1;
		}
			i2cstate = 5;
			while (SSPIF == 0 && TMR1IF == 0);	
	}
	else
	{
		i2cerrout = 0x33;	// general timeout on the write operation
	}
	SSPIF = 0;
	if (wr_plus_rd == 0)
	{
		PEN = 1;		// nor read follows, so stops here
		i2cstate = 6;
		while (SSPIF == 0	&& TMR1IF == 0);
		if (TMR1IF == 1 && i2cerrout == 0)
		{
			i2cerrout = 0x34;
		}
		SSPIF = 0;
	}
TMR1ON = 0;
TMR1IF = 0;
i2cstate = 7;
/* -------- rcv part */
	if ((nbin !=0) && (i2cerrout == 0))
	{
		count = SSPBUF;
		TMR1L = 1;
		TMR1H = 0;
		TMR1IF = 0;
		TMR1ON = 1;
		if (wr_plus_rd == 0)
		{
			SEN = 1;
		}
		else
		{
			RSEN = 1;
		}
		iadr = iadr | 1;
		while (SSPIF == 0 && TMR1IF == 0);
		while (SEN == 1 || RSEN == 1);
		SSPBUF= iadr;
		i2cstate = 8;
		SSPIF = 0;
		while (RW_ == 1);
		while (SSPIF == 0 && TMR1IF == 0);
		count = 0;
		if (TMR1IF == 1)
		{
			i2cerrin = 0x35;
		}
		if (ACKSTAT == 1)
		{
			i2cerrin = 0x36;
		}  
		while (nbin != 0 && i2cerrin ==0)
		{
			RCEN = 1;
			i2cstate = 9;
			SSPIF = 0;
			while (SSPIF == 0 && TMR1IF == 0);
			if (TMR1IF == 1 && i2cerrin == 0)
			{
				i2cerrin = 0x37;
			}		
			I2Cbufin[count] = SSPBUF;	//** get data
			count = count + 1;
			nbin = nbin - 1;
			nbrwr = nbin;
			if (TMR1IF == 1 && i2cerrin == 0)
			{
				i2cerrin = 0x38;
			}
			i2cstate = 10;
			SSPIF = 0;	
			ACKDT = 0;
			if (nbin == 0)
			{
				ACKDT = 1;	
			}
			ACKEN = 1;
			while (SSPIF == 0 && TMR1IF == 0);
			if (TMR1IF == 1 && i2cerrin ==0)
			{
				i2cerrin = 0x39;
			}
			i2cstate = 11;
			SSPIF = 0;
			ACKEN = 0;
		}
		i2cstate = 12;		
		SSPIF = 0;
		WCOL = 0;
		SSPOV = 0;
		PEN = 1;
		while (SSPIF == 0	&& TMR1IF == 0);
		if (TMR1IF == 1 && i2cerrin == 0)
		{
			i2cerrin = 0x41;
		}
	}
	i2cstate = 0;
	SSPIF = 0;
	TMR1ON = 0;
	TMR1IF = 0;
}
   


/* ********** ACCESS External Flash ************ */
/*
void writef (uns16 faddr, char nbrdata)
{
	I2Cbufout[0] = faddr.high8;	// used if type  > 16k
	I2Cbufout[1] = faddr.low8;
	iadr = 0xA0;
	I2Cout (2,0);
	tempo (10,1);
}
*/
/*************************************************
Lecture mmoire srial flash externe
Entre : uns16 pour adresse premier char, 
et nombre de char lus, max 64
********************************************/ 
void readflash (uns16 faddr, char nbrdata)
{
	iadr = 0xA0;
	I2Cbufout[0] = faddr.high8;		// necessary for type > 16k
	I2Cbufout[1] = faddr.low8;
	I2Cout (2,nbrdata); // data in I2Cbufin
}	
	